#include <htc.h>
#include "HW_Config.h"
#include "sdelay.h"
#include "seg7.h"
#include "sound.h"

#define N_MAX  10
#define pt_MAX 36

unsigned char pt;
char mem[34];
unsigned char flg_SW1;

unsigned char i, j, k, ii, jj;

extern void wait_SW1(unsigned char dsp);

unsigned char isSW1(unsigned char t);
void shuffle(unsigned char n);
void countdown(void);
void hit_ok(void);
void missed(void);
void dsp_lvl(void);
void dsp_pt2d(void);

void nezumi(void)
{
    unsigned char xr;
    xr = 0;


    for(i=0; i<5; i++)
    {
        while(!SW1);
        countdown();
        /*
        for(j=3; j>0; j--)
        {
            Set7Seg(Seg7[j]);
            sdelay_1s();
        }
         */
        prand();
        j = 0;
        flg_SW1 = 0;
        while(rnd & 0x0F && (flg_SW1 == 0))
        {

            xr += rnd % 5 + 1;
            if(xr > 5) xr -= 6;
            Set7Seg(SegR[xr]);
            sound_on(5, 5);
            isSW1(6);
            prand();
            /*
            for(k=0; k<10; k++)
            {
                if(!SW1)
                {
                    j = 20;
                    break;
                }
                __delay_ms(30);
            }
            */
        }
        if(!flg_SW1){
            Set7Seg(S_G);
            sound_on(5, 5);
            j = isSW1(20);
        }

        /*
        if(j<20)
        {
            Set7Seg(S_G);
            sound_on(5, 5);
            for(j=0; j<20 && SW1; j++)
            {
                sdelay_50ms();
            }
        }
        */
        pt+=j;
        if(j>0)
        {
            hit_ok();
         }
        else
        {
            missed();
            /*
            Set7Seg(SX);
            sound_on(0, 25);
            sdelay_100ms();
            */
        }
        while(!SW1);
        sdelay_1s();
    }
    //pt = 100 - pt;
    //dsp_2d(pt);
    dsp_pt2d();

    return;
    /*
    pt = 10-pt/20;
    if(pt>9) pt=9;
    Set7Seg(Seg7[pt]);
    sdelay_100ms();
     */
}


void slot(void)
{
    char slt[3];
    sdelay_500ms();
    for(i=0; i<3; i++)
    {
        while(!SW1);
        prand();
        j = rnd % N_MAX;
        do{
            if(++j >= N_MAX) j=0;
            Set7Seg(Seg7[j]);
            sound_on(5, 5);
            sdelay_50ms();
        }while(SW1);
        slt[i] = Seg7[j];
        sdelay_1s();
    }

    for(i=0; i<3; i++)
    {
        Set7Seg(Soff);
        sdelay_100ms();
        Set7Seg(slt[i]);
        sdelay_1s();
    }
    if(slt[0] == slt[1])
        if(slt[1] == slt[2])
            sound_pkmn();
            /*
    {
        for(i=0; i<10; i++)
        {
        Set7Seg(Soff);
        sdelay_100ms();
        Set7Seg(slt[0]);
        sound_on(7, 20);
        }
    }
             */

    return;
}

void hit2nd(void)
{

    unsigned char trg;  // target
    char dsp, dsp_trg;
    unsigned char i, j;

    //rnd = TMR0;

    for(pt = 6; pt<pt_MAX; pt++){
        shuffle(pt);
        prand();
        trg = pt - rnd % (pt>>1) - 1;
        prand();
        dsp_trg = rnd % (trg-2);
        dsp_lvl();

        // count down for start
        countdown();
        // game start
        for(i=0; i<trg; i++){
            Set7Seg(Seg7[mem[i]]);
            sound_on(5, 5);
            isSW1(20);
            if(flg_SW1){ // miss
                missed();
                dsp_lvl();
                return;
            }
        }

        // show the 2nd
        Set7Seg(Seg7[mem[dsp_trg]]);
        sound_on(5, 5);
        isSW1(20);
        if(flg_SW1){ // Hit
            hit_ok();
        }
        else{ // miss
            missed();
            dsp_lvl();
            return;
        }

    }   // end of for pt
    hit_ok();
    dsp_lvl();
    return;

}

void hitodds(void){
    unsigned char dsp, t;

    for(i=0; i<5; ){
        Set7Seg(Soff);
        while(!SW);
        sdelay_500ms();

        prand();
        dsp = rnd % 10;
        prand();
        t = (rnd % 100) +10;
        
        countdown();
        isSW1(t);
        if(!flg_SW1){
            //display Number
            Set7Seg(Seg7[dsp]);
            t = isSW1(20);
            if(dsp & 0x01){
                if(flg_SW1){
                    i++;
                    pt += t;
                    hit_ok();
                    sdelay_1s();
                    continue;
                }
            }
            else if(flg_SW1 == 0){
                continue;
            }
        }
        //missed
        i++;
        //pt += 20;
        missed();
        sdelay_1s();
    }

    //pt = pt>99 ? 0: 100 - pt;
    //dsp_2d(pt);
    dsp_pt2d();
    return;
}

unsigned char isSW1(unsigned char t){
    //unsigned char ii;
    IOCAN_SW1 = 1;
    if(!SW1){
        flg_SW1 = 1;
        return t;
    }
    IOCAF_SW1 = 0;
    flg_SW1 = 0;
    for(; t>0; t--){
        sdelay_50ms();
        if(IOCAF_SW1){
            flg_SW1 = 1;
            break;
        }
    }
    return t;
}

void shuffle(unsigned char n){
//    unsigned char ii, jj;
    char tmp;

    for(ii=0; ii<n; ii++){
        mem[ii] = ii;
    }

    for(ii=0; ii<n; ii++){
        prand();
        jj = rnd % n;
        tmp = mem[jj];
        mem[jj] = mem[ii];
        mem[ii] = tmp;
    }
}

void countdown(void){
//    unsigned char ii;

    for(ii=0; ii<4; ii++){
        Set7Seg(SegCD[ii]);
        if(ii==3)
            sound_on(7, 30);
        else
            sound_on(2, 30);
        sdelay_500ms();
        sdelay_200ms();
    }
}

void hit_ok(void){
//    unsigned char ii;
    Set7Seg(So);
    for(ii=0; ii<3; ii++)
    {
        sound_on(5, 10);
        sdelay_100ms();
    }
}

void missed(void){
    Set7Seg(SX);
    sound_on(0, 25);
    sdelay_100ms();
}

void dsp_lvl(void){
    while(!SW1);
    Set7Seg(SL);
    sdelay_1s();
    Set7Seg(Seg7[pt-1]);
    wait_SW1(0);
}


void dsp_pt2d(void){
//    unsigned char ii;
    for(ii=0; ii<10; ii++){
        Set7Seg(Seg7[pt / 10]);
        isSW1(20);
        if(flg_SW1) break;
        Set7Seg(Soff);
        sdelay_200ms();
        Set7Seg(Seg7[pt % 10]);
        isSW1(20);
        Set7Seg(Soff);
        sdelay_500ms();
        if(flg_SW1) break;
    }
    sdelay_100ms();
}

