#include <htc.h>
#include "sound.h"
#include "sdelay.h"
#include "HW_Config.h"
#define _XTAL_FREQ 4000000

void sound_on(unsigned char s, unsigned char t)
{
    // t / 10msec
    t0 = tone_prd[s];
    TMR0 = t0;
    INTCON = 0b11100000;            // GIE, PIE, T0IE = 1
    for(;t>0;t--)
        sdelay_10ms();
    SOUND_Soff();
}

void sound_pkmn(void){
    sound_on(4, 20);
    sdelay_200ms();
    sound_on(4, 20);
    sdelay_200ms();
    sound_on(4, 10);
    sdelay_100ms();
    sound_on(2, 10);
    sdelay_100ms();
    sound_on(7, 30);
}